# -*- coding: latin-1 -*-

from Products.Archetypes.public import BaseSchema, BaseFolderSchema, Schema

from Products.Archetypes.public import StringField, StringWidget
from Products.Archetypes.public import SelectionWidget, MultiSelectionWidget
from Products.Archetypes.public import TextField, TextAreaWidget
from Products.Archetypes.public import LinesField, LinesWidget
from Products.Archetypes.public import BooleanField, BooleanWidget
#from Products.Archetypes.public import IntegerField, IntegerWidget
#from Products.Archetypes.public import DateTimeField, CalendarWidget
from Products.Archetypes.public import FileField, FileWidget
from Products.Archetypes.public import RichWidget, VisualWidget
from Products.Archetypes.public import ReferenceField, ReferenceWidget

from DIYWidget import DIYWidget

from Products.Archetypes.public import BaseContent, registerType, DisplayList
from Products.Archetypes.Marshall import RFC822Marshaller, PrimaryFieldMarshaller

# product
from iso_countries import iso_countries

DEFAULT_CONTENT_TYPE = 'text/html'


#####################################################################
## Person
#####################################################################


mxmContacts_person_schema = BaseSchema + Schema((

# Snailmail info

    StringField('title',
        widget = StringWidget(
            label = 'Shortname',
            label_msgid = 'label_shortname',
            description = 'How the person is usually addressed.',
            description_msgid = 'help_shortname_creation',
            i18n_domain = 'mxmcontacts',
        ),
#        accessor='Title',
#        required = 1,
        searchable = 1,
    ),

    StringField('firstname',
        widget = StringWidget(
            label = 'First Name',
            label_msgid = 'label_firstname',
            description = "Enter your first name.",
            description_msgid = 'help_firstname_creation',
            i18n_domain = 'mxmcontacts',
        ),
        searchable = 1,
    ),

    StringField('lastname',
        widget = StringWidget(
            label = 'Last Name',
            label_msgid = 'label_lastname',
            description = "Enter your last name.",
            description_msgid = 'help_lastname_creation',
            i18n_domain = 'mxmcontacts',
        ),
    ),


    StringField('memberId',
        widget = DIYWidget(
            label = 'Member Id',
            label_msgid = 'label_memberId',
            description = "Select the member id of the contact.",
            description_msgid = 'help_memberId',
            i18n_domain = 'mxmcontacts',
            diy_method='memberIdWidget',
            condition="python: member.has_permission('Add portal member', object)"
        ),
    ),



    StringField('jobtitle',
        widget = StringWidget(
            label = 'Job Title',
            label_msgid = 'label_jobtitle',
            description = "Enter your job title.",
            description_msgid = 'help_jobtitle_creation',
            i18n_domain = 'mxmcontacts',          
        ),
        searchable = 1,
    ),

    StringField('address',
        widget = StringWidget(
            label = 'address',
            label_msgid = 'label_address',
            description = 'The contact persons address',
            description_msgid = 'help_address_creation',
            i18n_domain = 'mxmcontacts',  
        ),
        searchable = 1,
    ),

    StringField('city',
        widget = StringWidget(
            label = 'City',
            label_msgid = 'label_city',
            description = 'Enter your city',
            description_msgid = 'help_city_creation',
            i18n_domain = 'mxmcontacts',
        ),
        searchable = 1,
    ),

    StringField('po',
        widget = StringWidget(
            label = 'Po',
            label_msgid = 'label_po',
            description = 'Enter your Postal code',
            description_msgid = 'help_po_creation',
            i18n_domain = 'mxmcontacts',
        ),
        searchable = 1,
    ),

    StringField('misc',
        widget = StringWidget(
            label = 'Extra address information',
            label_msgid = 'label_misc',
            description = 'Enter your extra address',
            description_msgid = 'help_misc_creation',
            i18n_domain = 'mxmcontacts',
        ),
        searchable = 1,
    ),

    StringField('country',
        widget = StringWidget(
            label = 'Country',
            label_msgid = 'label_country',
            description = 'Enter the country name',
            description_msgid = 'help_country_creation',
            i18n_domain = 'mxmcontacts',
        ),
        searchable = 1,
    ),

#    StringField('country',
#        widget = SelectionWidget(
#            format = 'flex',
#            label = 'Country',
#        ),
#        searchable = 1,
#        default='DK',
#        vocabulary = DisplayList(iso_countries)
#    ),

# affiliation

    ReferenceField('organization',
        widget = ReferenceWidget (
            checkbox_bound = 2,
            label = 'Organization',
            label_msgid = 'label_organization_name',
            description = 'Select your organization',
            description_msgid = 'help_select_organization_creation',
            i18n_domain = 'mxmcontacts',
        ),
#        allowed_types=('mxmContactsOrganization',),
        vocabulary='getOrganizationsDisplaylist',
        vocabulary_custom_label='b.getObject().title_or_id()',
        relationship='mxmContacts_employed_at',
        multiValued=False,
    ),


    StringField('organizationName',
        widget = StringWidget(
            label = 'Organization name',
            label_msgid = 'label_organization_name',
            description = 'Name of the persons organization of employment',
            description_msgid = 'help_organization',
            i18n_domain = 'mxmcontacts',
        ),
        searchable = 1,
    ),

    StringField('department',
        widget = StringWidget(
            label = 'Department',
            label_msgid='label_department',
            description = 'The organization department',
            description_msgid='help_department_creation',
            i18n_domain='mxmcontacts',
        ),
        searchable = 1,
    ),

# E-info

    StringField('email',
        widget = DIYWidget(
            label='E-mail',
            label_msgid='label_email_address',
            description='Enter your email address.',
            description_msgid='help_email_creation', 
            i18n_domain='mxmcontacts',
            diy_method='ConditionalStringWidget_edit',
       ),
        accessor='getEmail',
        searchable = 1,
    ),


    StringField('web',
        widget = StringWidget(
            label = 'Web address',
            label_msgid='label_web',
            description='Enter your web address.',
            description_msgid='help_web_creation', 
            i18n_domain='mxmcontacts',
        ),
#        validators=("isUrl",),
        searchable = 1,
    ),

    StringField('office_phone',
        widget = StringWidget(
            label = 'Office phone',
            label_msgid='label_office_phone',
            description='Enter your office phone.',
            description_msgid='help_office_phone_creation', 
            i18n_domain='mxmcontacts',
        ),
        searchable = 1,
    ),

    StringField('mobile_phone',
        widget = StringWidget(
            label = 'Mobile phone',
            label_msgid='label_mobile_phone',
            description='Enter your mobile phone.',
            description_msgid='help_mobile_phone_creation', 
            i18n_domain='mxmcontacts',
        ),
        searchable = 1,
    ),

    StringField('private_phone',
        widget = StringWidget(
            label = 'Private phone',
            label_msgid='label_private_phone',
            description='Enter your private phone.',
            description_msgid='help_private_phone_creation', 
            i18n_domain='mxmcontacts',
        ),
        searchable = 1,
    ),

    StringField('fax',
        widget = StringWidget(
            label = 'Fax',
            label_msgid='label_fax',
            description='Enter your fax.',
            description_msgid='help_fax_creation', 
            i18n_domain='mxmcontacts',
        ),
        searchable = 1,
    ),

# xtra

    StringField('greeting',
        widget = StringWidget(
            label = 'greeting',
            label_msgid='label_greeting',
            description='Default greeting when sending messages to this contact',
            description_msgid='help_greeting_creation', 
            i18n_domain='mxmcontacts',
        ),
        searchable = 1,
    ),

#    TextField('body',
#              searchable = 1,
#              primary = 1,
##              validators = ('isTidyHtmlWithCleanup',),
#              default_content_type = DEFAULT_CONTENT_TYPE,
#              default_output_type = 'text/html',
#              allowable_content_types = ('text/structured',
#                                         'text/restructured',
#                                         'text/html',
#                                         'text/plain',
#                                         ),
#              widget = RichWidget(
#                        description = "The body text of the document.",
#                        description_msgid = "help_body_text",
#                        label = "Body text",
#                        label_msgid = "label_body_text",
#                        rows = 25,
#                        i18n_domain = "plone")),
#    ),
    TextField('body',
              searchable = 1,
              primary = 1,
              default_content_type = DEFAULT_CONTENT_TYPE,
              default_output_type = 'text/plain',
              allowable_content_types = ('text/structured',
                                         'text/restructured',
                                         'text/plain',
                                         ),
              widget = TextAreaWidget(
                        description = "The body text of the document.",
                        description_msgid = "help_body_text",
                        label = "Body text",
                        label_msgid = "label_body_text",
                        rows = 25,
                        i18n_domain = "mxmcontacts")),
    ),
    marshall=RFC822Marshaller()

)



#####################################################################
## Organization
#####################################################################

mxmContacts_organization_schema = BaseSchema + Schema((

    StringField('title',
        widget = StringWidget(
            label = 'Organization name',
            label_msgid='label_organization_name',
            description='Full name of the organization.',
            description_msgid='help_organization_creation', 
            i18n_domain='mxmcontacts',
        ),
        accessor='Title',
        required = 1,
        searchable = 1,
    ),

# snailmail info

    StringField('address',
        widget = StringWidget(
            label = 'address',
            label_msgid = 'label_address',
            description = 'Enter the address',
            description_msgid = 'help_address_creation',
            i18n_domain = 'mxmcontacts',  
        ),
        searchable = 1,
    ),

    StringField('city',
        widget = StringWidget(
            label = 'City',
            label_msgid = 'label_city',
            description = 'Enter your city',
            description_msgid = 'help_city_creation',
            i18n_domain = 'mxmcontacts',
        ),
        searchable = 1,
    ),

    StringField('misc',
        widget = StringWidget(
            label = 'Extra address information',
            label_msgid = 'label_misc',
            description = 'Enter your extra address',
            description_msgid = 'help_misc_creation',
            i18n_domain = 'mxmcontacts',
        ),
        searchable = 1,
    ),

    StringField('po',
        widget = StringWidget(
            label = 'Po',
            label_msgid = 'label_po',
            description = 'Enter your Postal code',
            description_msgid = 'help_po_creation',
            i18n_domain = 'mxmcontacts',
        ),
        searchable = 1,
    ),

    StringField('country',
        widget = StringWidget(
            label = 'Country',
            label_msgid = 'label_country',
            description = 'Enter the country name',
            description_msgid = 'help_country_creation',
            i18n_domain = 'mxmcontacts',
        ),
        searchable = 1,
    ),

# E-info

    StringField('email',
        widget = StringWidget(
            label='E-mail',
            label_msgid='label_email_address',
            description='Enter your email address.',
            description_msgid='help_email_creation', 
            i18n_domain='mxmcontacts',
        ),
#        validators=("isEmail",),
        searchable = 1,
    ),

    StringField('web',
        widget = StringWidget(
            label = 'Web address',
            label_msgid='label_web',
            description='Enter your web address.',
            description_msgid='help_web_creation', 
            i18n_domain='mxmcontacts',
        ),
#        validators=("isUrl",),
        searchable = 1,
    ),

    StringField('phone',
        widget = StringWidget(
            label = 'Phone',
            label_msgid='label_private_phone',
            description='Enter your phone.',
            description_msgid='help_phone_creation', 
            i18n_domain='mxmcontacts',
        ),
        searchable = 1,
    ),

    StringField('fax',
        widget = StringWidget(
            label = 'Fax',
            label_msgid='label_fax',
            description='Enter your fax.',
            description_msgid='help_fax_creation', 
            i18n_domain='mxmcontacts',
        ),
        searchable = 1,
    ),

    TextField('body',
              searchable = 1,
              primary = 1,
              default_content_type = DEFAULT_CONTENT_TYPE,
              default_output_type = 'text/plain',
              allowable_content_types = ('text/structured',
                                         'text/restructured',
                                         'text/plain',
                                         ),
              widget = TextAreaWidget(
                        description = "The body text of the document.",
                        description_msgid = "help_body_text",
                        label = "Body text",
                        label_msgid = "label_body_text",
                        rows = 25,
                        i18n_domain = "mxmcontacts")),
    ),
    marshall=RFC822Marshaller()

)



#####################################################################
## Resource
#####################################################################

mxmContacts_resource_schema = BaseSchema + Schema((

    StringField('title',
        widget = StringWidget(
            label = 'Resource name',
            label_msgid='label_resource',
            description='Name of the resource.',
            description_msgid='help_resource_creation',
            i18n_domain='mxmcontacts',
        ),
        accessor='Title',
        required = 1,
        searchable = 1,
    ),

# E-info


    ReferenceField('resource_owner',
        widget = ReferenceWidget(
            checkbox_bound = 2,
            label = 'Owner',
            label_msgid='label_owner_resource',
            description='Responsible/owner of the resource',
            description_msgid='help_owner_resource_creation',
            i18n_domain='mxmcontacts',
        ),
        allowed_types=('mxmContactsPerson', 'mxmContactsOrganization',),
        vocabulary_custom_label='b.getObject().title_or_id()',
        relationship='resource_owner',
    ),

    TextField('body',
              searchable = 1,
              primary = 1,
              default_content_type = DEFAULT_CONTENT_TYPE,
              default_output_type = 'text/plain',
              allowable_content_types = ('text/structured',
                                         'text/restructured',
                                         'text/plain',
                                         ),
              widget = TextAreaWidget(
                        description = "The body text of the document.",
                        description_msgid = "help_body_text",
                        label = "Body text",
                        label_msgid = "label_body_text",
                        rows = 25,
                        i18n_domain = "mxmcontacts")),
    ),
    marshall=RFC822Marshaller()


)



#####################################################################
## Group
#####################################################################

mxmContacts_group_schema = BaseSchema + Schema((

    StringField('title',
        widget = StringWidget(
            label = 'ContactGroup name',
            label_msgid='label_contact_group',
            description='Name of the ContactGroup.',
            description_msgid='help_contact_group_creation',
            i18n_domain='mxmcontacts',
        ),
        accessor='Title',
        required = 1,
        searchable = 1,
    ),

    TextField('description',
        widget = TextAreaWidget(
            label = 'Description',
            label_msgid='label_description_group',
            description='A short description of the content',
            description_msgid='help_description_group_creation',
            i18n_domain='mxmcontacts',
        ),
        accessor='Description',
        searchable = 1,
    ),

    TextField('text',
              searchable=True,
              validators = ('isTidyHtmlWithCleanup',),
              default_content_type = 'text/html',
              default_output_type = 'text/x-html-safe',
              widget = RichWidget(
                        description = "",
                        description_msgid = "help_body_text",
                        label = "Body Text",
                        label_msgid = "label_body_text",
                        rows = 25,
                        i18n_domain = "plone",
        )
    ),

    BooleanField('anonymousForm',
        widget = BooleanWidget(
            label = 'Anonymous form',
            label_msgid = 'label_anonymousForm',
            description = "Let anonymous add their contact info.",
            description_msgid = 'help_anonymousForm',
            i18n_domain = 'mxmcontacts',
        ),
        default=False,
    ),

    BooleanField('showMembersList',
        widget = BooleanWidget(
            label = 'Show member list',
            label_msgid = 'label_showMembersList',
            description = "Show the members list on the frontpage.",
            description_msgid = 'help_showMembersList',
            i18n_domain = 'mxmcontacts',
        ),
        default=True,
    ),

    BooleanField('anonymousUnsubscribe',
        widget = BooleanWidget(
            label = 'Unsubscribe by URL',
            label_msgid = 'label_anonymousUnsubscribe',
            description = "Allow 'anonymous' users to unsubscribe their contact info via an URL.",
            description_msgid = 'help_anonymousUnsubscribe',
            i18n_domain = 'mxmcontacts',
        ),
        default = False,
    ),

    ), marshall=RFC822Marshaller()

)


# the possibility to add custom schemas for contacts
try:
    import schemasCustom
    if hasattr(schemasCustom, 'mxmContacts_person_schema') and \
                        schemasCustom.mxmContacts_person_schema:
        mxmContacts_person_schema = mxmContacts_person_schema + \
                          schemasCustom.mxmContacts_person_schema
                                    
    if hasattr(schemasCustom, 'mxmContacts_organization_schema') and \
                        schemasCustom.mxmContacts_organization_schema:
        mxmContacts_organization_schema = mxmContacts_organization_schema + \
                                schemasCustom.mxmContacts_organization_schema
    
    if hasattr(schemasCustom, 'mxmContacts_organization_schema') and \
                        schemasCustom.mxmContacts_organization_schema:
        mxmContacts_organization_schema = mxmContacts_organization_schema + \
                                schemasCustom.mxmContacts_organization_schema
    
    if hasattr(schemasCustom, 'mxmContacts_group_schema') and \
                        schemasCustom.mxmContacts_group_schema:
        mxmContacts_group_schema = mxmContacts_group_schema + \
                         schemasCustom.mxmContacts_group_schema
except ImportError:
    pass

